//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  HotPink
#property indicator_color3  EMPTY
#property indicator_color4  DarkGray
#property indicator_width1  10
#property indicator_width2  10
#property indicator_width3  10
#property indicator_width4  2
#property indicator_minimum -50
#property indicator_maximum +50

//
//
//
//
//

extern int    Stochastic_Period    = 55;
extern int    Ema_Smoothing_Period = 15;
extern double Up_Level             = 80;
extern double Down_Level           = 20;

double sto[];
double stoHu[];
double stoHd[];
double stoHn[];
double inZone[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,stoHu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,stoHd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,stoHn); 
   SetIndexBuffer(3,sto);
   SetIndexBuffer(4,inZone);
      SetLevelValue(0,Up_Level-50.0);
      SetLevelValue(1,Down_Level-50.0);
         IndicatorShortName("Double smoothed stochastic ("+Stochastic_Period+","+Ema_Smoothing_Period+")");
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(0);
      if (counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         
         bool initialized=false;
         if (!initialized)
         {
            initialized = true; SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,EMPTY,GetWindowBackgroundColor());
         }
 
   //
   //
   //
   //
   //
 
   for(int i=limit; i>=0; i--)
   {
      stoHu[i]  = EMPTY_VALUE;
      stoHd[i]  = EMPTY_VALUE;
      stoHn[i]  = EMPTY_VALUE;
      sto[i]    = iDss(Stochastic_Period,Ema_Smoothing_Period,i)-50.0;
      inZone[i] = inZone[i+1];
         if (sto[i]>(Up_Level-50.0))                             inZone[i] =  1;
         if (sto[i]<(Down_Level-50.0))                           inZone[i] = -1;
         if (sto[i]<(Up_Level-50.0) && sto[i]>(Down_Level-50.0)) inZone[i] =  0;
         if (inZone[i] ==  1) { stoHu[i] = sto[i]; stoHn[i] = (Up_Level  -50.0); }
         if (inZone[i] == -1) { stoHd[i] = sto[i]; stoHn[i] = (Down_Level-50.0); }
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workDss[][2];
double iDss(int StochasticPeriod, int EMAPeriod, int i, int instanceNo=0)
{
   if (ArrayRange(workDss,0) != Bars) ArrayResize(workDss,Bars); int r=Bars-i-1; instanceNo*=2;

   //
   //
   //
   //
   //

      double alpha = 2.0/(1.0+EMAPeriod);
      double rsto  = 0;
      double max   = High[i]; 
      double min   = Low[i];
         for(int k=1; k<StochasticPeriod; k++)
         {
            max = MathMax(max,High[i+k]);
            min = MathMin(min,Low [i+k]);
         }            
         if (max!=min) rsto = (Close[i]-min)/(max-min)*100.00;

         workDss[r][instanceNo] = workDss[r-1][instanceNo]+alpha*(rsto-workDss[r-1][instanceNo]);
      
         //
         //
         //
         //
         //
      
         rsto = 0;
         max  = workDss[r][instanceNo]; 
         min  = workDss[r][instanceNo];
            for(k=1; k<StochasticPeriod; k++)
            {
               max = MathMax(max,workDss[r-k][instanceNo]);
               min = MathMin(min,workDss[r-k][instanceNo]);
            }
            if (max!=min) rsto = (workDss[r][instanceNo]-min)/(max-min)*100.00;

         workDss[r][instanceNo+1] = workDss[r-1][instanceNo+1]+alpha*(rsto-workDss[r-1][instanceNo+1]);

         //
         //
         //
         //
         //
         
   return(workDss[r][instanceNo+1]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#import "user32.dll"
   int GetDC(int _1);
   int ReleaseDC(int _1, int _2);
#import "gdi32.dll"
   int GetPixel(int _1, int _2, int _3);
#import

//
//
//
//
//

int GetWindowBackgroundColor()
{
   int handle    = WindowHandle(Symbol(), Period());
   int context   = GetDC(handle);
   int backColor = GetPixel(context,1,2);
                   ReleaseDC(handle,context);
   return (backColor);
}